<script setup lang="ts">
import { onMounted, reactive } from 'vue'
import FormStepper from '@/components/FormStepper.vue'
import { useRouter } from 'vue-router'
import AppCard from '@/components/ui/AppCard.vue'
import AppButton from '@/components/ui/AppButton.vue'
import YearbookExamples from '@/components/YearbookExamples.vue'
import FormExtraPictureBox from '@/components/FormExtraPictureBox.vue'
import { GlobalError, useAppStore } from '@/stores/app'
import { useMyDataStore } from '@/stores/my-data'

const app = useAppStore()
const myData = useMyDataStore()
const router = useRouter()

class OtherUpload {
  imageUrl = null as string | null
  loading = false
  error = false

  private file = null as File | null
  private xhr = null as XMLHttpRequest | null
  private index = null as number | null

  uploadFile(index: number, file: File) {
    if (this.xhr != null) {
      return
    }
    this.index = index
    this.file = file
    this.imageUrl = URL.createObjectURL(file)
    this.loading = true
    this.xhr = new XMLHttpRequest()

    this.xhr.addEventListener('loadend', () => {
      this.loading = false
      this.error = this.xhr?.readyState !== 4 || this.xhr?.status !== 200
      if (this.error) {
        if (this.xhr?.status === 413) {
          app.setGlobalError(GlobalError.UploadTooLarge)
        } else {
          app.setGlobalError(GlobalError.ActionFailedError)
        }
      }
      loadOtherPictures()
      this.xhr = null
    })

    this.xhr.open('POST', `/api/user/other-picture/${index}`, true)
    this.xhr.setRequestHeader('Authorization', 'Bearer ' + app.sessionKey)

    const formData = new FormData()
    formData.set('file', this.file)
    this.xhr.send(formData)
  }

  setPicture(index: number, url: string) {
    this.index = index
    this.imageUrl = url
  }

  clear() {
    if (this.index == null) {
      return
    }
    if (this.xhr != null) {
      this.xhr.abort()
      this.xhr = null
    }
    this.loading = true
    myData
      .deleteOtherPicture(this.index)
      .then(() => {
        this.index = null
        this.file = null
        this.imageUrl = null
        loadOtherPictures()
      })
      .finally(() => {
        this.loading = false
      })
  }
}

const state = reactive({
  questionTeacher: '',
  confirmLoading: true,
  uploads: [] as OtherUpload[]
})

function loadOtherPictures() {
  myData.getOtherPictures().then((pictures) => {
    let picturesCount = 0
    let uploads = pictures.map((p) => {
      const u = new OtherUpload()
      if (p != null) {
        u.setPicture(p.index, p.url)
        picturesCount++
      }
      return u
    })
    if (picturesCount > 0 && uploads.length < 6) {
      uploads.push(new OtherUpload())
    } else if (pictures.length === 0) {
      uploads.push(new OtherUpload())
    }
    state.uploads = uploads
    state.questionTeacher =
      state.questionTeacher.length > 0 ? state.questionTeacher : myData.user!.question_teacher ?? ''
  })
}

onMounted(() => {
  loadOtherPictures()
})

function validate() {
  state.confirmLoading = true
  myData
    .updateExtra(state.questionTeacher)
    .then(() => {
      myData
        .confirm()
        .then((ok) => {
          if (ok) {
            router.push('/form/done')
          }
        })
        .finally(() => {
          state.confirmLoading = false
        })
    })
    .finally(() => {
      state.confirmLoading = false
    })
}
</script>

<template>
  <main>
    <section class="bg-white antialiased dark:bg-gray-900 md:py-8">
      <div class="mx-auto max-w-screen-xl px-4 2xl:px-0">
        <div class="mx-auto max-w-5xl">
          <FormStepper :current-step="3" />

          <hr class="h-px my-3 lg:my-8 bg-gray-200 border-0 dark:bg-gray-700" />

          <div class="grid grid-cols-1 lg:grid-cols-3 gap-y-5 lg:gap-x-3">
            <h2 class="text-xl font-semibold text-gray-900 dark:text-white sm:text-2xl">
              {{ $t('formExtra.title') }}
            </h2>
            <div class="col-span2"></div>
            <div class="col-span-2 space-y-3">
              <AppCard :title="$t('formExtra.questionTeacher')">
                <input
                  v-model="state.questionTeacher"
                  type="text"
                  class="block w-full rounded-lg border border-gray-300 bg-gray-50 p-2.5 text-sm text-gray-900 focus:border-primary-500 focus:ring-primary-500 dark:border-gray-600 dark:bg-gray-700 dark:text-white dark:placeholder:text-gray-400 dark:focus:border-primary-500 dark:focus:ring-primary-500"
                  placeholder="Martin Vetterli"
                  required
                />
              </AppCard>
              <AppCard
                :title="$t('formExtra.otherPictures')"
                :description="$t('formExtra.otherPicturesDescription')"
              >
                <div class="grid grid-rows-subgrid grid-cols-3 gap-3">
                  <FormExtraPictureBox
                    v-for="(u, i) in state.uploads"
                    v-bind:key="i"
                    :index="i"
                    :imageUrl="u.imageUrl"
                    :loading="u.loading"
                    @clear="() => state.uploads[i].clear()"
                    @update="(file) => state.uploads[i].uploadFile(i, file)"
                  />
                </div>
                <p
                  class="mt-2 text-center text-sm text-gray-500 dark:text-gray-300"
                  id="file_input_help"
                >
                  {{ $t('formExtra.uploadRequirements') }}
                </p>
              </AppCard>
              <div class="text-right">
                <AppButton @click="validate" variant="outlined"
                  >{{ $t('ui.validateSubmission') }}
                </AppButton>
              </div>
            </div>
            <div class="">
              <YearbookExamples dense />
            </div>
          </div>
        </div>
      </div>
    </section>
  </main>
</template>
